<template>
      <form @submit="addOffer">
      <b-field label="Start date">
        <b-datepicker
          placeholder="Start date for contracts based on this offer"
          icon="calendar-today"
          v-model="offerForm.startDate">
        </b-datepicker>
      </b-field>
      <b-field label="End date">
        <b-datepicker
          placeholder="End date for contracts based on this offer (leave empty for no specified end date)"
          icon="calendar-today"
          v-model="offerForm.endDate"
          :icon-right="offerForm.endDate ? 'close-circle' : ''"
          icon-right-clickable
          @icon-right-click="removeEndDate">
        </b-datepicker>
      </b-field>
      <b-field label="Rules">
        <div class="form-rule mb-5" v-for="(rule, idx) in offerForm.rules" :key="`rule${idx}`">
          <b-field label="Assigner" message="Agent that assignes this rule, leave empty to match all agents on this connector" horizontal>
            <b-input v-model="rule.assignerAgent" placeholder="Assigner"></b-input>
            <b-select placeholder="Select agent from list"
                    v-model="assignerSelect[idx]">
                <option
                    value="">
                    Match all
                </option>
                <option
                    v-for="agent in agents"
                    :value="agent.id"
                    :key="agent.id">
                    {{ agent.id }} - {{ agent.title }}
                </option>
            </b-select>
          </b-field>
          <b-field label="Assignee" message="Agent that will be assigned to this rule, leave empty to match all agents in the dataspace" horizontal>
            <b-input v-model="rule.assigneeAgent" placeholder="Assigner"></b-input>
          </b-field>
          <b-field label="Version" horizontal>
            <b-input v-model="rule.version" placeholder="Version (regex)"></b-input>
          </b-field>
          <b-field label="Endpoint" horizontal>
            <b-input v-model="rule.endpoint" placeholder="Endpoint (regex)"></b-input>
          </b-field>
          <b-field label="Methods" horizontal>
            <div class="block">
                <b-checkbox v-model="rule.methods"
                    type="is-info"
                    native-value="GET">
                    GET
                </b-checkbox>
                <b-checkbox v-model="rule.methods"
                    type="is-success"
                    native-value="POST">
                    POST
                </b-checkbox>
                <b-checkbox v-model="rule.methods"
                    type="is-warning"
                    native-value="PUT">
                    PUT
                </b-checkbox>
                <b-checkbox v-model="rule.methods"
                    type="is-warning"
                    native-value="PUT">
                    PATCH
                </b-checkbox>
                <b-checkbox v-model="rule.methods"
                    type="is-danger"
                    native-value="DELETE">
                    DELETE
                </b-checkbox>
                <b-checkbox v-model="rule.methods"
                    type="is-info"
                    native-value="GET">
                    OPTIONS
                </b-checkbox>
                <b-checkbox v-model="rule.methods"
                    type="is-info"
                    native-value="GET">
                    HEAD
                </b-checkbox>
                <b-checkbox v-model="rule.methods"
                    type="is-info"
                    native-value="GET">
                    TRACE
                </b-checkbox>
            </div>
          </b-field>
          <b-field label="Permission" horizontal>
            <div class="block">
              <b-radio v-model="rule.permission"
                  native-value="ALLOW">
                  Allow
              </b-radio>
              <b-radio v-model="rule.permission"
                  native-value="DENY">
                  Deny
              </b-radio>
            </div>
          </b-field>
          <b-field horizontal>
            <b-button type="is-danger"
                  icon-right="delete"
                  @click="() => { offerForm.rules.splice(idx, 1) }">
                  Remove rule
            </b-button>
          </b-field>
        </div>

          <b-field horizontal>
            <b-button type="is-success"
                    icon-right="plus"
                    @click="() => { offerForm.rules.push({assignerAgent: '', assigneeAgent: '', version: '.*', endpoint: '.*', methods: ['GET', 'POST', 'PUT'], permission: 'ALLOW'}) }">
              Add rule
            </b-button>
          </b-field>
      </b-field>
      <b-field>
        <b-button type="is-success" @click="addOffer">Submit offer</b-button>
      </b-field>
    </form>
</template>

<script lang="ts">
import { Vue, Component, Prop, Watch } from 'vue-property-decorator'
import { PolicyAgent } from '../model'
import axios from 'axios';

@Component
export default class PolicyForm extends Vue {
  agentsInterval = -1
  offerForm: {
    startDate?: Date,
    endDate?: Date,
    rules: Array<{
      assignerAgent?: string,
      assigneeAgent?: string,
      version?: string,
      endpoint?: string,
      methods: Array<string>,
      permission?: string
    }>
  } = {
    rules: [],
    startDate: new Date(new Date().toDateString())
  }

  assignerSelect: Array<string> = []
  assignerSelectOld: Array<string> = []
  agents: Array<PolicyAgent> = []

  private api = axios.create({
    baseURL: 'policies',
  });

  async created() {
    await this.getAgents();
    this.agentsInterval = setInterval(this.getAgents, 15000);
  }

  async getAgents() {
    const agents = await this.api.get('agents');
    this.agents = agents.data;
  }

  @Watch('assignerSelect')
  onPropertyChanged(value: Array<string>, oldValue: Array<string>) {
    for (let idx = 0; idx < value.length; idx++) {
      if (value[idx] !== this.assignerSelectOld[idx]) {
        this.offerForm.rules[idx].assignerAgent = value[idx]
      }
    }
    this.assignerSelectOld = this.assignerSelect.slice()
  }

  async addOffer() {
    if (this.offerForm.rules.length === 0) {
      this.$buefy.toast.open({
        message: 'No policy rules configured',
        type: 'is-danger',
        duration: 5000
      });
      return
    }
    this.offerForm.rules.forEach((rule) => {
      if (rule.assignerAgent === '') {
        rule.assignerAgent = undefined;
      }
      if (rule.assigneeAgent === '') {
        rule.assigneeAgent = undefined;
      }
      rule.endpoint = rule.endpoint?.replace(/^\//, '')
    });
    console.log(this.offerForm);
    await this.api.post('offers', this.offerForm);
    this.$emit('refreshOffers');
    this.offerForm = {
      rules: [],
      startDate: new Date(new Date().toDateString())
    }
  }

  removeEndDate() {
    this.offerForm.endDate = undefined;
    setTimeout(() => {
      document.getElementsByTagName('body')[0].click()
    }, 100)
  }
}
</script>